// Copyright © 2005, Esko Luontola <www.orfjackal.net>
// This software is released under the Apache License 2.0.
// The license text is at http://www.apache.org/licenses/LICENSE-2.0

package net.orfjackal.util;

/**
 * Library class of miscellaneous methods.
 *
 * @author Esko Luontola
 */
public class Tools {

    private static boolean debug = false;

    /**
     * Returns true if assertions are enabled, otherwise false.
     */
    @SuppressWarnings({"UnusedAssignment", "ConstantConditions"})
    public static boolean isAssertionsEnabled() {
        boolean enabled = false;
        assert enabled = true;
        return enabled;
    }

    /**
     * Returns true if debug mode is enabled, otherwise false. If assertions are enabled, then debug mode is always
     * enabled.
     *
     * @return true if debug mode is on, otherwise off.
     */
    public static boolean isDebug() {
        return debug || isAssertionsEnabled();
    }

    /**
     * Enabled or disabled debug mode. Will have no effect if assertions are enabled.
     *
     * @param debug true to enable debug mode, false to disable.
     */
    public static void setDebug(boolean debug) {
        Tools.debug = debug;
    }
}
