// Copyright © 2005, Esko Luontola <www.orfjackal.net>
// This software is released under the Apache License 2.0.
// The license text is at http://www.apache.org/licenses/LICENSE-2.0

package net.orfjackal.util.commandline;

import org.jetbrains.annotations.NotNull;

import java.text.ParseException;

/**
 * Standard option for displaying the command help.
 *
 * @author Esko Luontola
 */
public class HelpOption extends Option {

    @NotNull
    private CommandLineParser parser;

    public HelpOption(CommandLineParser parser) {
        super(null, "help", "display this help and exit");
        if (parser == null) {
            throw new NullPointerException();
        }
        this.parser = parser;
    }

    public void onSpecified(String arg) throws ParseException {
        System.out.print(parser.getHelp());
        System.exit(0);
    }
}
