// Tietorakenteiden harjoitusty (syksy 2004), Esko Luontola
// Tietoliikenneverkon reititysalgoritmien vertailu, "Sim Router"

/**
 * SendPortteja sisltv prioriteettijono, jossa pienimmn timeoutin
 * omaava SendPort on ensimmisen.
 */
public class TimeoutQueue {
	
	/**
	 * Prioriteettijonon toteuttava keko.
	 */
	private Heap heap = new Heap() {
		protected boolean isGreaterOrEqual(int first, int last) {
			return ((SendPort)get(first)).getTimeout() <= ((SendPort)get(last)).getTimeout();
		}
	};
	
	/**
	 * Luo uuden jonon.
	 */
	public TimeoutQueue() {}
	
	/**
	 * Lis alkion jonoon.
	 */
	public void push(SendPort obj) {
		heap.push(obj);
	}
	
	/**
	 * Poistaa ensimmisen alkion jonosta.
	 */
	public SendPort pop() {
		return (SendPort)heap.pop();
	}
	
	/**
	 * Palauttaa jonon ensimmisen alkion.
	 */
	public SendPort getFirst() {
		return (SendPort)heap.getFirst();
	}
	
	/**
	 * Palauttaa jonon alkioiden lukumrn.
	 */
	public int size() {
		return heap.size();
	}
}
